<?
/*

   Dailystrips Dynamic Images

== Introduction ==

The dailystrips script really is nice ... but something irked me still.
I loaded strips from around the world, so not all strips had been
online the time I read them. Sometimes I found a strip and thought
"Damn, there's a bit of the story missing!" Now I need a quick way to 
find the strip of yesterday -- both ways offered did not fit me. My
strips page is wayyy to big to load quickly, mostly due to the
Astronomy Picture of the Day (big image).
And using the original strip pages ... uuh, well, no, I just don't like
the ads and polls on comics.com.

So, to make the whole story short, I wrote a quick hack to insert some
javascript to dynamically change the image to a older one.

== Installation/Usage ==

Just put the index.php next to the index.html of dailystrips and
enter the URL to index.php into your browser.
There is no further configuration possible (apart from making sure 
that your apache runs .php scripts).

== License ==

Copyright (c) 2007, Dave Kliczbor <maligree@gmx.de>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <ORGANIZATION> nor the names of its
      contributors may be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/

# general idea: read the index.html, make a few modifications, output the modified document
$f = file('index.html');

$dh = opendir('.');
$files = array();
while( ($filename = readdir($dh)) !== false ) {
  if( !is_link($filename) ) {
    # dailystrips sets symlinks when downloading the same image as on the previous day
    # so we only look for filenames which are not a symlink _and_ matches the pattern
    $files[] = $filename;
  }
}
closedir($dh);

$o = array();
foreach($f as $n => $l) {
  if( preg_match('/^(\s*\<img)\s+src="((.*?)-(\d{4})\.(\d{2})\.(\d{2})(.*?))"(.*)$/', $l, $m) ) {
    # does the line contain an image tag?
    # if yes, do the central work
    # the regex matches are now in $m[0] .. $m[8]

    # we need an unique ID for getElementById() for each cartoon
    # fortunately, dailystrips titles _have_ to be different, else one strip would overwrite another...
    $css_id = substr(md5($m[3]),1,9);
    
    # first, we need a list of all files of a specific cartoon
    $fileprefix = urldecode(str_replace("+", "%2B", $m[3]));
    # start simple directory reading
    $a = array();
    foreach($files as $filename) {
      if( preg_match('/^'.preg_quote($fileprefix).'.*$/', $filename) ) {
        $a[] = $filename;
      }
    }
    # all filenames of one strip are now in $a -- but we need it in reverse order, newest at $a[0]!
    rsort($a);
    # put the filenames into a JS array
    $o[] = '
      <script type="text/javascript">
      var list_'.$css_id.' = Array("'.join('", "', $a).'");
      var pos_'.$css_id.' = 0;
      </script>
    ';
    # write the links for relative navigation
    $o[]= '
      <p style="font-size:70%">[ <a href="" onClick="sir(\''.$css_id.'\', 1); return false;">older</a>
      | <span id="text_'.$css_id.'">strip 0: '.urldecode(str_replace("+", "%2B", $m[2])).'</span> |
      <a href="" onClick="sir(\''.$css_id.'\', -1); return false;">newer</a> ]<br />
      [ oldest: 
    ';
    # write the links for absolute navigation
    foreach( array_reverse($a, true) as $n => $fil ) {
      $o[] = '<a href="'.$fil.'" onClick="sia(\''.$css_id.'\', '.$n.'); return false;">'.$n.'</a> ';
    }
    $o[] = ':newest ]</p>';
    # write the <img> tag, now with an unique id!
    $o[] = $m[1] . ' id="'.$css_id.'" src="'.$m[2].'"'.$m[8];
    
  } elseif( preg_match('/\<\/head\>/', $l, $m)) {
    # or does the line contain the last line of the html header?
    # if yes, just insert the javascript functions
    $o[] = '
      <script type="text/javascript">
      // set image absolute
      function sia(img_id, img_nr) {
        var pos;
        var list;
        var text;
        eval("pos = pos_"+img_id+";");
        eval("list = list_"+img_id+";");
        eval("text_id = \'text_"+img_id+"\';");
        if( img_nr >= 0 && img_nr < list.length && document.getElementById ) {
          document.getElementById(img_id).src = list[img_nr];
          document.getElementById(text_id).textContent = "strip "+img_nr+": "+list[img_nr];
          eval("pos_"+img_id+" = img_nr;");
        }
        return false;
      }
      // set image relative
      function sir(img_id, offset) {
        var pos;
        var list;
        var text;
        eval("pos = pos_"+img_id+";");
        eval("list = list_"+img_id+";");
        eval("text = \'text_"+img_id+"\';");
        var npos = pos + offset;
        if( npos >= 0 && npos < list.length && document.getElementById ) {
          document.getElementById(img_id).src = list[npos];
          document.getElementById(text).textContent = "strip "+npos+": "+list[npos];
          eval("pos_"+img_id+" = npos;");
        }
        return false;
      }
      </script>
    ';
    
    $o[] = $m[0];
  } else {
    # else just output the input line unchanged
    $o[] = $l;
  }
}

# here's the output
foreach($o as $n => $l) {
  print $l;
}

?>